change#3534 didn't preserve undef return values from caller()
[p5sagit/p5-mst-13.2.git] / t / io / pipe.t
1 #!./perl
2
3 # $RCSfile: pipe.t,v $$Revision: 4.1 $$Date: 92/08/07 18:27:31 $
4
5 BEGIN {
6     chdir 't' if -d 't';
7     unshift @INC, '../lib';
8     require Config; import Config;
9     unless ($Config{'d_fork'}) {
10         print "1..0 # Skip: no fork\n";
11         exit 0;
12     }
13 }
14
15 $| = 1;
16 print "1..14\n";
17
18 # External program 'tr' assumed.
19 open(PIPE, "|-") || (exec 'tr', 'YX', 'ko');
20 print PIPE "Xk 1\n";
21 print PIPE "oY 2\n";
22 close PIPE;
23
24 if ($^O eq 'vmesa') {
25     # Doesn't work, yet.
26     for (3..6) {
27         print "ok $_ # skipped\n";
28     }
29 } else {
30     if (open(PIPE, "-|")) {
31         while(<PIPE>) {
32             s/^not //;
33             print;
34         }
35         close PIPE;        # avoid zombies which disrupt test 12
36     }
37     else {
38         # External program 'echo' assumed.
39         print STDOUT "not ok 3\n";
40         exec 'echo', 'not ok 4';
41     }
42
43     pipe(READER,WRITER) || die "Can't open pipe";
44
45     if ($pid = fork) {
46         close WRITER;
47         while(<READER>) {
48             s/^not //;
49             y/A-Z/a-z/;
50             print;
51         }
52         close READER;     # avoid zombies which disrupt test 12
53     }
54     else {
55         die "Couldn't fork" unless defined $pid;
56         close READER;
57         print WRITER "not ok 5\n";
58         open(STDOUT,">&WRITER") || die "Can't dup WRITER to STDOUT";
59         close WRITER;
60         # External program 'echo' assumed.
61         exec 'echo', 'not ok 6';
62     }
63 }
64 wait;                           # Collect from $pid
65
66 pipe(READER,WRITER) || die "Can't open pipe";
67 close READER;
68
69 $SIG{'PIPE'} = 'broken_pipe';
70
71 sub broken_pipe {
72     $SIG{'PIPE'} = 'IGNORE';       # loop preventer
73     print "ok 7\n";
74 }
75
76 print WRITER "not ok 7\n";
77 close WRITER;
78 sleep 1;
79 print "ok 8\n";
80
81 # VMS doesn't like spawning subprocesses that are still connected to
82 # STDOUT.  Someone should modify tests #9 to #12 to work with VMS.
83
84 if ($^O eq 'VMS') {
85     print "ok 9 # skipped\n";
86     print "ok 10 # skipped\n";
87     print "ok 11 # skipped\n";
88     print "ok 12 # skipped\n";
89     exit;
90 }
91
92 if ($Config{d_sfio} || $^O eq 'machten' || $^O eq 'beos' || $^O eq 'posix-bc') {
93     # Sfio doesn't report failure when closing a broken pipe
94     # that has pending output.  Go figure.  MachTen doesn't either,
95     # but won't write to broken pipes, so nothing's pending at close.
96     # BeOS will not write to broken pipes, either.
97     # Nor does POSIX-BC.
98     print "ok 9 # skipped\n";
99 }
100 else {
101     local $SIG{PIPE} = 'IGNORE';
102     open NIL, '|true'   or die "open failed: $!";
103     sleep 2;
104     print NIL 'foo'     or die "print failed: $!";
105     if (close NIL) {
106         print "not ok 9\n";
107     }
108     else {
109         print "ok 9\n";
110     }
111 }
112
113 if ($^O eq 'vmesa') {
114     # These don't work, yet.
115     print "ok 10 # skipped\n";
116     print "ok 11 # skipped\n";
117     print "ok 12 # skipped\n";
118     exit;
119 }
120
121 # check that errno gets forced to 0 if the piped program exited non-zero
122 open NIL, '|exit 23;' or die "fork failed: $!";
123 $! = 1;
124 if (close NIL) {
125     print "not ok 10\n# successful close\n";
126 }
127 elsif ($! != 0) {
128     print "not ok 10\n# errno $!\n";
129 }
130 elsif ($? == 0) {
131     print "not ok 10\n# status 0\n";
132 }
133 else {
134     print "ok 10\n";
135 }
136
137 # check that status for the correct process is collected
138 my $zombie = fork or exit 37;
139 my $pipe = open *FH, "sleep 2;exit 13|" or die "Open: $!\n";
140 $SIG{ALRM} = sub { return };
141 alarm(1);
142 my $close = close FH;
143 if ($? == 13*256 && ! length $close && ! $!) {
144     print "ok 11\n";
145 } else {
146     print "not ok 11\n# close $close\$?=$?   \$!=", $!+0, ":$!\n";
147 };
148 my $wait = wait;
149 if ($? == 37*256 && $wait == $zombie && ! $!) {
150     print "ok 12\n";
151 } else {
152     print "not ok 12\n# pid=$wait first=$pid pipe=$pipe zombie=$zombie me=$$ \$?=$?   \$!=", $!+0, ":$!\n";
153 }
154
155 # Test new semantics for missing command in piped open
156 # 19990114 M-J. Dominus mjd@plover.com
157 { local *P;
158   print (((open P, "|    " ) ? "not " : ""), "ok 13\n");
159   print (((open P, "     |" ) ? "not " : ""), "ok 14\n");
160 }